Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5600)
@@ -4125,5 +4494,5 @@
       !----------------------------------------------------------------
       il_dim=4
-      IF( PRESENT(DIM) )il_dim=DIM
+      IF( PRESENT(DIM) ) il_dim=DIM
 
       IF( .NOT. ASSOCIATED(td_var1%d_value) )THEN
@@ -4138,28 +4507,26 @@
          ! check other dimension
          SELECT CASE(il_dim)
-         CASE(1)
+         CASE(jp_I)
             var_concat=var__concat_i(td_var1, td_var2)
-         CASE(2)
+         CASE(jp_J)
             var_concat=var__concat_j(td_var1, td_var2)
-         CASE(3)
+         CASE(jp_K)
             var_concat=var__concat_k(td_var1, td_var2)
-         CASE(4)
+         CASE(jp_L)
             var_concat=var__concat_l(td_var1, td_var2)
          END SELECT
-
       ENDIF
 
    END FUNCTION var_concat
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief  This function concatenate variable value following i-direction.
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var1 : variable structure
-   !> @param[in] td_var2 : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var1   variable structure
+   !> @param[in] td_var2   variable structure
+   !> @return variable structure
+   !-------------------------------------------------------------------
    FUNCTION var__concat_i(td_var1, td_var2)
       IMPLICIT NONE
@@ -4176,6 +4543,9 @@
 
       !----------------------------------------------------------------
-      IF( ANY(td_var1%t_dim(2:4)%i_len /=  td_var2%t_dim(2:4)%i_len) )THEN
-         CALL logger_error("VAR CONCAT: dimension not conform")
+      IF( .NOT. td_var1%t_dim(1)%l_use .OR. &
+      &   .NOT. td_var1%t_dim(1)%l_use )THEN
+         CALL logger_error("VAR CONCAT: can not concatenate variable "//&
+         &  TRIM(td_var1%c_name)//" on an unused dimension I")
+      ELSEIF( ANY(td_var1%t_dim(2:4)%i_len /=  td_var2%t_dim(2:4)%i_len) )THEN
 
          cl_tmp='('//":"//","//&
@@ -4191,6 +4561,8 @@
          CALL logger_debug("VAR CONCAT: second variable dimensions "//&
          &  TRIM(cl_tmp) )
+
+         CALL logger_error("VAR CONCAT: dimension not conform")
       ELSE
-         tl_var=td_var1
+         tl_var=var_copy(td_var1)
 
          DEALLOCATE(tl_var%d_value)
@@ -4212,21 +4584,21 @@
 
          ! save result
-         var__concat_i=tl_var
-
+         var__concat_i=var_copy(tl_var)
+
+         ! clean
          CALL var_clean(tl_var)
       ENDIF
 
    END FUNCTION var__concat_i
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief  This function concatenate variable value following j-direction.
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var1 : variable structure
-   !> @param[in] td_var2 : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var1   variable structure
+   !> @param[in] td_var2   variable structure
+   !> @return variable structure
+   !-------------------------------------------------------------------
    FUNCTION var__concat_j(td_var1, td_var2)
       IMPLICIT NONE
@@ -4243,7 +4615,10 @@
 
       !----------------------------------------------------------------
-      IF(     td_var1%t_dim(1)%i_len   /=  td_var2%t_dim(1)%i_len  .OR. &
+      IF( .NOT. td_var1%t_dim(2)%l_use .OR. &
+      &   .NOT. td_var1%t_dim(2)%l_use )THEN
+         CALL logger_error("VAR CONCAT: can not concatenate variable "//&
+         &  TRIM(td_var1%c_name)//" on an unused dimension J")      
+      ELSEIF(     td_var1%t_dim(1)%i_len   /=  td_var2%t_dim(1)%i_len  .OR. &
       &   ANY(td_var1%t_dim(3:4)%i_len /=  td_var2%t_dim(3:4)%i_len) )THEN
-         CALL logger_error("VAR CONCAT: dimension not conform")
 
          cl_tmp='('//&
@@ -4261,6 +4636,8 @@
          CALL logger_debug("VAR CONCAT: second variable dimensions "//&
          &  TRIM(cl_tmp) )
+
+         CALL logger_error("VAR CONCAT: dimension not conform")
       ELSE
-         tl_var=td_var1
+         tl_var=var_copy(td_var1)
 
          DEALLOCATE(tl_var%d_value)
@@ -4282,21 +4659,21 @@
 
          ! save result
-         var__concat_j=tl_var
-
+         var__concat_j=var_copy(tl_var)
+
+         ! clean
          CALL var_clean(tl_var)
       ENDIF
 
    END FUNCTION var__concat_j
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief  This function concatenate variable value following k-direction.
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var1 : variable structure
-   !> @param[in] td_var2 : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var1   variable structure
+   !> @param[in] td_var2   variable structure
+   !> @return variable structure
+   !-------------------------------------------------------------------
    FUNCTION var__concat_k(td_var1, td_var2)
       IMPLICIT NONE
@@ -4313,7 +4690,10 @@
 
       !----------------------------------------------------------------
-      IF(     td_var1%t_dim(4)%i_len   /=  td_var2%t_dim(4)%i_len  .OR. &
+      IF( .NOT. td_var1%t_dim(3)%l_use .OR. &
+      &   .NOT. td_var1%t_dim(3)%l_use )THEN
+         CALL logger_error("VAR CONCAT: can not concatenate variable "//&
+         &  TRIM(td_var1%c_name)//" on an unused dimension K")      
+      ELSEIF(     td_var1%t_dim(4)%i_len   /=  td_var2%t_dim(4)%i_len  .OR. &
       &   ANY(td_var1%t_dim(1:2)%i_len /=  td_var2%t_dim(1:2)%i_len) )THEN
-         CALL logger_error("VAR CONCAT: dimension not conform")
 
          cl_tmp='('//&
@@ -4331,6 +4711,8 @@
          CALL logger_debug("VAR CONCAT: second variable dimensions "//&
          &  TRIM(cl_tmp) )
+
+         CALL logger_error("VAR CONCAT: dimension not conform")
       ELSE
-         tl_var=td_var1
+         tl_var=var_copy(td_var1)
 
          DEALLOCATE(tl_var%d_value)
@@ -4352,21 +4734,21 @@
 
          ! save result
-         var__concat_k=tl_var
-
+         var__concat_k=var_copy(tl_var)
+
+         ! clean
          CALL var_clean(tl_var)
       ENDIF
 
    END FUNCTION var__concat_k
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief  This function concatenate variable value following l-direction.
    !> 
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var1 : variable structure
-   !> @param[in] td_var2 : variable structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var1   variable structure
+   !> @param[in] td_var2   variable structure
+   !> @return variable structure
+   !-------------------------------------------------------------------
    FUNCTION var__concat_l(td_var1, td_var2)
       IMPLICIT NONE
@@ -4383,6 +4765,9 @@
 
       !----------------------------------------------------------------
-      IF( ANY(td_var1%t_dim(1:3)%i_len /=  td_var2%t_dim(1:3)%i_len) )THEN
-         CALL logger_error("VAR CONCAT: dimension not conform")
+      IF( .NOT. td_var1%t_dim(4)%l_use .OR. &
+      &   .NOT. td_var1%t_dim(4)%l_use )THEN
+         CALL logger_error("VAR CONCAT: can not concatenate variable "//&
+         &  TRIM(td_var1%c_name)//" on an unused dimension L")      
+      ELSEIF( ANY(td_var1%t_dim(1:3)%i_len /=  td_var2%t_dim(1:3)%i_len) )THEN
 
          cl_tmp='('//&
@@ -4400,6 +4785,8 @@
          CALL logger_debug("VAR CONCAT: second variable dimensions "//&
          &  TRIM(cl_tmp) )
+
+         CALL logger_error("VAR CONCAT: dimension not conform")
       ELSE
-         tl_var=td_var1
+         tl_var=var_copy(td_var1)
 
          DEALLOCATE(tl_var%d_value)
@@ -4421,23 +4808,22 @@
 
          ! save result
-         var__concat_l=tl_var
-
+         var__concat_l=var_copy(tl_var)
+
+         ! clean
          CALL var_clean(tl_var)
       ENDIF
 
    END FUNCTION var__concat_l
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a table of attribute structure 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add an array of attribute structure 
    !> in a variable structure.
-   !
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_att : table of attribute structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_att_tab(td_var, td_att)
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_att    array of attribute structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_att_arr(td_var, td_att)
       IMPLICIT NONE
       ! Argument      
@@ -4458,19 +4844,15 @@
       ENDDO
 
-   END SUBROUTINE var__add_att_tab
-   !> @endcode   
+   END SUBROUTINE var__add_att_arr
    !-------------------------------------------------------------------
    !> @brief This subroutine add an attribute structure 
    !> in a variable structure.
    !
-   !> @details
-   !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_att : attribute structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_att    attribute structure
+   !-------------------------------------------------------------------
    SUBROUTINE var__add_att_unit(td_var, td_att)
       IMPLICIT NONE
@@ -4481,5 +4863,5 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_attid
+      INTEGER(i4) :: il_ind
       TYPE(TATT), DIMENSION(:), ALLOCATABLE :: tl_att
 
@@ -4489,24 +4871,24 @@
 
       ! check if attribute already in variable structure
-      il_attid=0
+      il_ind=0
       IF( ASSOCIATED(td_var%t_att) )THEN
-         il_attid=att_get_id( td_var%t_att(:), td_att%c_name )
-      ENDIF
-
-      IF( il_attid /= 0 )THEN
+         il_ind=att_get_index( td_var%t_att(:), td_att%c_name )
+      ENDIF
+
+      IF( il_ind /= 0 )THEN
 
          CALL logger_error( &
-         &  " ADD ATT: attribute "//TRIM(td_att%c_name)//&
+         &  " VAR ADD ATT: attribute "//TRIM(td_att%c_name)//&
          &  ", already in variable "//TRIM(td_var%c_name) )
 
          DO ji=1,td_var%i_natt
             CALL logger_debug( &
-            &  " ADD ATT: in variable "//TRIM(td_var%t_att(ji)%c_name) )
+            &  " VAR ADD ATT: in variable "//TRIM(td_var%t_att(ji)%c_name) )
          ENDDO
 
       ELSE
          
-         CALL logger_debug( &
-         &  " ADD ATT: add attribute "//TRIM(td_att%c_name)//&
+         CALL logger_trace( &
+         &  " VAR ADD ATT: add attribute "//TRIM(td_att%c_name)//&
          &  ", in variable "//TRIM(td_var%c_name) )
 
@@ -4517,5 +4899,5 @@
 
                CALL logger_error( &
-               &  " ADD ATT: not enough space to put attributes from "//&
+               &  " VAR ADD ATT: not enough space to put attributes from "//&
                &  TRIM(td_var%c_name)//" in temporary attribute structure")
 
@@ -4523,6 +4905,7 @@
 
                ! save temporary global attribute's variable structure
-               tl_att(:)=td_var%t_att(:)
-
+               tl_att(:)=att_copy(td_var%t_att(:))
+
+               CALL att_clean(td_var%t_att(:))
                DEALLOCATE( td_var%t_att )
                ALLOCATE( td_var%t_att(td_var%i_natt+1), stat=il_status )
@@ -4530,5 +4913,5 @@
 
                   CALL logger_error( &
-                  &  " ADD ATT: not enough space to put attributes "//&
+                  &  " VAR ADD ATT: not enough space to put attributes "//&
                   &  "in variable structure "//TRIM(td_var%c_name) )
 
@@ -4536,6 +4919,8 @@
 
                ! copy attribute in variable before
-               td_var%t_att(1:td_var%i_natt)=tl_att(:)
-
+               td_var%t_att(1:td_var%i_natt)=att_copy(tl_att(:))
+
+               ! clean
+               CALL att_clean(tl_att(:))
                DEALLOCATE(tl_att)
                
@@ -4544,4 +4929,5 @@
          ! no attribute in variable structure
             IF( ASSOCIATED(td_var%t_att) )THEN
+               CALL att_clean(td_var%t_att(:))
                DEALLOCATE(td_var%t_att)
             ENDIF
@@ -4550,5 +4936,5 @@
 
                CALL logger_error( &
-               &  " ADD ATT: not enough space to put attributes "//&
+               &  " VAR ADD ATT: not enough space to put attributes "//&
                &  "in variable structure "//TRIM(td_var%c_name) )
 
@@ -4558,11 +4944,9 @@
          td_var%i_natt=td_var%i_natt+1
 
-         ! add new attributes
-         td_var%t_att(td_var%i_natt)=td_att
-
-         ! change attribute id
-         DO ji=1,td_var%i_natt
-            td_var%t_att(ji)%i_id=ji
-         ENDDO
+         ! add new attribute
+         td_var%t_att(td_var%i_natt)=att_copy(td_att)
+
+         !! add new attribute id
+         !td_var%t_att(td_var%i_natt)%i_id=att_get_unit(td_var%t_att(:))
 
          ! highlight some attribute
@@ -4577,8 +4961,14 @@
                CASE("_FillValue")
                   td_var%d_fill = td_var%t_att(td_var%i_natt)%d_value(1)
+               CASE("ew_overlap")
+                  td_var%i_ew = INT(td_var%t_att(td_var%i_natt)%d_value(1),i4) 
                CASE("standard_name")
                   td_var%c_stdname = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+               CASE("long_name")
+                  td_var%c_longname = TRIM(td_var%t_att(td_var%i_natt)%c_value)
                CASE("units")
                   td_var%c_units = TRIM(td_var%t_att(td_var%i_natt)%c_value)
+               CASE("grid_point")
+                  td_var%c_point = TRIM(td_var%t_att(td_var%i_natt)%c_value)
 
             END SELECT
@@ -4587,19 +4977,56 @@
 
    END SUBROUTINE var__add_att_unit
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine delete an attribute 
    !> from variable structure.
    !
-   !> @details
-   !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_att : attribute structure
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_del_att(td_var, td_att)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] cd_name   attribute name
+   !-------------------------------------------------------------------
+   SUBROUTINE var__del_att_name(td_var, cd_name)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR)      , INTENT(INOUT) :: td_var
+      CHARACTER(LEN=*), INTENT(IN   ) :: cd_name
+
+      ! local variable
+      INTEGER(i4) :: il_ind
+
+      ! loop indices
+      !----------------------------------------------------------------
+
+      ! check if attribute already in variable structure
+      il_ind=0
+      IF( ASSOCIATED(td_var%t_att) )THEN
+         il_ind=att_get_index( td_var%t_att(:), TRIM(cd_name) )
+      ENDIF
+
+      IF( il_ind == 0 )THEN
+
+         CALL logger_warn( &
+         &  " VAR DEL ATT: no attribute "//TRIM(cd_name)//&
+         &  ", in variable "//TRIM(td_var%c_name) )
+
+      ELSE
+         
+         CALL var_del_att(td_var, td_var%t_att(il_ind))
+
+      ENDIF
+
+   END SUBROUTINE var__del_att_name
+   !-------------------------------------------------------------------
+   !> @brief This subroutine delete an attribute 
+   !> from variable structure.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_att    attribute structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var__del_att_str(td_var, td_att)
       IMPLICIT NONE
       ! Argument      
@@ -4609,31 +5036,32 @@
       ! local variable
       INTEGER(i4) :: il_status
-      INTEGER(i4) :: il_attid
+      INTEGER(i4) :: il_ind
       TYPE(TATT), DIMENSION(:), ALLOCATABLE :: tl_att
 
       ! loop indices
-      INTEGER(i4) :: ji
+      !INTEGER(i4) :: ji
       !----------------------------------------------------------------
 
       ! check if attribute already in variable structure
-      il_attid=0
+      il_ind=0
       IF( ASSOCIATED(td_var%t_att) )THEN
-         il_attid=att_get_id( td_var%t_att(:), td_att%c_name )
-      ENDIF
-
-      IF( il_attid == 0 )THEN
+         il_ind=att_get_index( td_var%t_att(:), td_att%c_name )
+      ENDIF
+
+      IF( il_ind == 0 )THEN
 
          CALL logger_warn( &
-         &  " DEL ATT: no attribute "//TRIM(td_att%c_name)//&
+         &  " VAR DEL ATT: no attribute "//TRIM(td_att%c_name)//&
          &  ", in variable "//TRIM(td_var%c_name) )
 
       ELSE
          
-         CALL logger_debug( &
-         &  " DEL ATT: del attribute "//TRIM(td_att%c_name)//&
+         CALL logger_trace( &
+         &  " VAR DEL ATT: del attribute "//TRIM(td_att%c_name)//&
          &  ", in var "//TRIM(td_var%c_name) )
 
          IF( td_var%i_natt == 1 )THEN
 
+            CALL att_clean(td_var%t_att(:))
             DEALLOCATE(td_var%t_att)
 
@@ -4646,5 +5074,5 @@
 
                CALL logger_error( &
-               &  " ADD ATT: not enough space to put attributes from "//&
+               &  " VAR ADD ATT: not enough space to put attributes from "//&
                &  TRIM(td_var%c_name)//" in temporary attribute structure")
 
@@ -4652,9 +5080,10 @@
 
                ! save temporary global attribute's variable structure
-               tl_att(1:il_attid-1)=td_var%t_att(1:il_attid-1)
-               IF( il_attid < td_var%i_natt )THEN
-                  tl_att(il_attid:)=td_var%t_att(il_attid+1:)
+               tl_att(1:il_ind-1)=att_copy(td_var%t_att(1:il_ind-1))
+               IF( il_ind < td_var%i_natt )THEN
+                  tl_att(il_ind:)=att_copy(td_var%t_att(il_ind+1:))
                ENDIF
 
+               CALL att_clean(td_var%t_att(:))
                DEALLOCATE( td_var%t_att )
 
@@ -4666,5 +5095,5 @@
 
                   CALL logger_error( &
-                  &  " ADD ATT: not enough space to put attributes "//&
+                  &  " VAR ADD ATT: not enough space to put attributes "//&
                   &  "in variable structure "//TRIM(td_var%c_name) )
 
@@ -4672,11 +5101,13 @@
 
                ! copy attribute in variable before
-               td_var%t_att(1:td_var%i_natt)=tl_att(:)
-
-               ! change attribute id
-               DO ji=1,td_var%i_natt
-                  td_var%t_att(ji)%i_id=ji
-               ENDDO
-
+               td_var%t_att(1:td_var%i_natt)=att_copy(tl_att(:))
+
+               !! change attribute id
+               !DO ji=1,td_var%i_natt
+               !   td_var%t_att(ji)%i_id=ji
+               !ENDDO
+
+               ! clean
+               CALL att_clean(tl_att(:))
                DEALLOCATE(tl_att)
             ENDIF 
@@ -4684,20 +5115,15 @@
       ENDIF
 
-   END SUBROUTINE var_del_att
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine move a global attribute structure 
+   END SUBROUTINE var__del_att_str
+   !-------------------------------------------------------------------
+   !> @brief This subroutine move an attribute structure 
    !> from variable structure.
    !
-   !> @details
-   !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_att : attribute structure
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_att    attribute structure
+   !-------------------------------------------------------------------
    SUBROUTINE var_move_att(td_var, td_att)
       IMPLICIT NONE
@@ -4711,5 +5137,5 @@
       !----------------------------------------------------------------
       ! copy attribute
-      tl_att=td_att
+      tl_att=att_copy(td_att)
 
       ! remove attribute with same name
@@ -4719,8 +5145,10 @@
       CALL var_add_att(td_var, tl_att)
 
+      ! clean
+      CALL att_clean(tl_att)
+
    END SUBROUTINE var_move_att
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a table of dimension structure in a variable 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add an array of dimension structure in a variable 
    !> structure.
    !> - number of dimension in variable can't be greater than 4
@@ -4728,13 +5156,10 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_dim_tab(td_var, td_dim)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_dim_arr(td_var, td_dim)
       IMPLICIT NONE
       ! Argument      
@@ -4749,5 +5174,5 @@
       !----------------------------------------------------------------
       il_ndim=SIZE(td_dim(:))
-      IF( il_ndim <= 4 )THEN
+      IF( il_ndim <= ip_maxdim )THEN
 
          DO ji=1,il_ndim
@@ -4757,85 +5182,191 @@
       ELSE
          CALL logger_error( &
-         &  " ADD DIM: too much dimension to put in structure "//&
+         &  " VAR ADD DIM: too much dimension to put in structure "//&
          &  "("//TRIM(fct_str(il_ndim))//")" )
       ENDIF
 
-   END SUBROUTINE var__add_dim_tab
-   !> @endcode   
+   END SUBROUTINE var__add_dim_arr
    !-------------------------------------------------------------------
    !> @brief This subroutine add one dimension in a variable 
-   !> structure, after some check.
+   !> structure.
+   !> @details
    !> - number of dimension in variable can't be greater than 4
    !> - dimension can't be already uses in variable structure 
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_dim_unit(td_var, td_dim)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_dim_unit(td_var, td_dim) 
       IMPLICIT NONE
       ! Argument      
-      TYPE(TVAR), INTENT(INOUT) :: td_var
-      TYPE(TDIM), INTENT(IN) :: td_dim
+      TYPE(TVAR)      , INTENT(INOUT) :: td_var
+      TYPE(TDIM)      , INTENT(IN   ) :: td_dim
 
       ! local variable
+      INTEGER(i4) :: il_ind
+
+      !----------------------------------------------------------------
+
+      IF( td_var%i_ndim <= 4 )THEN
+
+         ! check if dimension already used in variable structure
+         il_ind=SCAN(TRIM(cp_dimorder),TRIM(td_dim%c_sname))
+         IF( il_ind == 0 )THEN
+            CALL logger_warn( &
+            &  " VAR ADD DIM: dimension "//TRIM(td_dim%c_name)//&
+            &  ", short name "//TRIM(td_dim%c_sname)//&
+            &  ", will not be added in variable "//TRIM(td_var%c_name) )
+         ELSEIF( td_var%t_dim(il_ind)%l_use )THEN
+            CALL logger_error( &
+            &  " VAR ADD DIM: dimension "//TRIM(td_dim%c_name)//&
+            &  ", short name "//TRIM(td_dim%c_sname)//&
+            &  ", already used in variable "//TRIM(td_var%c_name) )
+         ELSE
+
+         ! back to unorder dimension array 
+         CALL dim_unorder(td_var%t_dim(:))
+            ! add new dimension
+            td_var%t_dim(td_var%i_ndim+1)=dim_copy(td_dim)
+
+            ! update number of attribute
+            td_var%i_ndim=COUNT(td_var%t_dim(:)%l_use)
+
+         ENDIF
+         ! reorder dimension to ('x','y','z','t')
+         CALL dim_reorder(td_var%t_dim(:))
+
+      ELSE
+         CALL logger_error( &
+         &  " VAR ADD DIM: too much dimension in variable "//&
+         &  TRIM(td_var%c_name)//" ("//TRIM(fct_str(td_var%i_ndim))//")")
+      ENDIF
+
+   END SUBROUTINE var__add_dim_unit
+   !-------------------------------------------------------------------
+   !> @brief This subroutine delete a dimension structure in a variable 
+   !> structure.
+   !
+   !> @warning delete variable value too.
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var_del_dim(td_var, td_dim)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR)      , INTENT(INOUT) :: td_var
+      TYPE(TDIM)      , INTENT(IN   ) :: td_dim
+
+      ! local variable
+      INTEGER(i4) :: il_ind
+      INTEGER(i4), DIMENSION(ip_maxdim) :: il_shape
+
+      TYPE(TDIM)  :: tl_dim ! empty dimension structure
+
+      !----------------------------------------------------------------
+
+      IF( td_var%i_ndim <= 4 )THEN
+
+         CALL logger_trace( &
+         &  " VAR DEL DIM: delete dimension "//TRIM(td_dim%c_name)//&
+         &  ", short name "//TRIM(td_dim%c_sname)//&
+         &  ", in variable "//TRIM(td_var%c_name) )
+         
+         ! check if dimension already in variable structure
+         il_ind=SCAN(TRIM(cp_dimorder),TRIM(td_dim%c_sname))
+
+         ! replace dimension by empty one
+         td_var%t_dim(il_ind)=dim_copy(tl_dim)
+
+         ! update number of dimension
+         td_var%i_ndim=COUNT(td_var%t_dim(:)%l_use)
+
+         ! remove variable value using this dimension
+         IF( ASSOCIATED(td_var%d_value) )THEN
+            il_shape(:)=SHAPE(td_var%d_value(:,:,:,:))
+            IF(il_shape(il_ind)/=td_dim%i_len)THEN
+               CALL logger_warn("VAR DEL DIM: remove value of variable "//&
+               &  TRIM(td_var%c_name) )
+               CALL var_del_value(td_var)
+            ENDIF
+         ENDIF
+
+         ! reorder dimension to ('x','y','z','t')
+         CALL dim_reorder(td_var%t_dim)
+
+      ELSE
+         CALL logger_error( &
+         &  " VAR DEL DIM: too much dimension in variable "//&
+         &  TRIM(td_var%c_name)//" ("//TRIM(fct_str(td_var%i_ndim))//")")
+      ENDIF
+
+   END SUBROUTINE var_del_dim
+   !-------------------------------------------------------------------
+   !> @brief This subroutine move a dimension structure 
+   !> in variable structure.
+   !>
+   !> @warning 
+   !> - dimension order could be changed
+   !> - delete variable value 
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] td_dim    dimension structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var_move_dim(td_var, td_dim)
+      IMPLICIT NONE
+      ! Argument      
+      TYPE(TVAR)      , INTENT(INOUT) :: td_var
+      TYPE(TDIM)      , INTENT(IN   ) :: td_dim
+
+      ! local variable
+      INTEGER(i4) :: il_ind
       INTEGER(i4) :: il_dimid
       !----------------------------------------------------------------
-      IF( td_var%i_ndim <= 4 )THEN
-
-         ! check if dimension already used in variable structure
-         il_dimid=dim_get_id( td_var%t_dim(:), td_dim%c_name, td_dim%c_sname )
-
-         IF( il_dimid == 0 )THEN
-
-               ! add dimension
-               CALL var__add_dim(td_var, td_dim)
+
+      IF( td_var%i_ndim <= ip_maxdim )THEN
+
+         ! check if dimension already in mpp structure
+         il_ind=dim_get_index(td_var%t_dim(:), td_dim%c_name, td_dim%c_sname)
+         IF( il_ind /= 0 )THEN
+
+            il_dimid=td_var%t_dim(il_ind)%i_id
+            ! replace dimension
+            td_var%t_dim(il_ind)=dim_copy(td_dim)
+            td_var%t_dim(il_ind)%i_id=il_dimid
+            td_var%t_dim(il_ind)%l_use=.TRUE.
 
          ELSE
-
-            IF( td_var%t_dim(il_dimid)%l_use )THEN
-
-               CALL logger_error( &
-               &  " ADD DIM: dimension "//TRIM(td_dim%c_name)//&
-               &  ", short name "//TRIM(td_dim%c_sname)//&
-               &  ", already used in variable "//TRIM(td_var%c_name) )
-            ELSE
-               ! add dimension
-               CALL var__add_dim(td_var, td_dim)
-            ENDIF
-
+            CALL var_add_dim(td_var, td_dim)
          ENDIF
 
       ELSE
          CALL logger_error( &
-         &  " ADD DIM: too much dimension in variable "//&
+         &  "VAR MOVE DIM: too much dimension in variale "//&
          &  TRIM(td_var%c_name)//" ("//TRIM(fct_str(td_var%i_ndim))//")")
       ENDIF
 
-   END SUBROUTINE var__add_dim_unit
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a dimension structure in a variable 
-   !> structure.
-   !
+   END SUBROUTINE var_move_dim
+   !-------------------------------------------------------------------
+   !> @brief This subroutine print informations of an array of variables. 
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_dim(td_var, td_dim)
+   !> - June, 2014- Initial Version
+   !
+   !> @param[in] td_var array of variables structure
+   !-------------------------------------------------------------------
+   SUBROUTINE var__print_arr(td_var)
       IMPLICIT NONE
+
       ! Argument      
-      TYPE(TVAR), INTENT(INOUT) :: td_var
-      TYPE(TDIM), INTENT(IN) :: td_dim
+      TYPE(TVAR), DIMENSION(:), INTENT(IN) :: td_var
 
       ! loop indices
